<template lang="html">
  <div class="play-view">
    <ep-404 v-if="show404"></ep-404>
    <div v-else-if="activeGame.app && (hasBrowserSupport || ignoreBrowserSupport)
      && isAccessVerified && hasAccess"
      class="game-container">
      <div class="">
        <ep-spinner class="spinner-icon"></ep-spinner>
        <div class="countdown-timer"
          v-bind:class="{ hide: countdownTimer <= 0, pulse: countdownTimerPulse }">
          {{ countdownTimer }}
        </div>
      </div>
      <div class="game-frame-container" ref="frameContainer">
        <iframe class="game-frame"
          ref="frame"
          :src="gameWebURL"
          v-on:mouseover="setFrameFocus()"
          frameBorder="0"
          sandbox="allow-same-origin allow-scripts allow-forms allow-pointer-lock"></iframe>
      </div>
    </div>
    <div v-else-if="!hasBrowserSupport && !ignoreBrowserSupport">
      <ep-browser-support
        :gid="activeGame.gid"
        :browser-desktop-list="browserDeviceList(label.DESKTOP)"
        :browser-mobile-list="browserDeviceList(label.MOBILE)"
        v-on:ignore-browser-support="setIgnoreBrowserSupport($event)"></ep-browser-support>
    </div>
    <div v-else-if="accessRequired" class="access-required-message">
      <div class="game-details-item-container">
        <ep-game-item-vert
          class="game-details-item"
          :gid="activeGame.gid"
          :thumbnail="activeGame.thumbnail"
          :title="activeGame.title"
          :publisher="activeGame.publisher"
          :price="activeGame.price"></ep-game-item-vert>
      </div>
      <ep-require-access class="require-access"
        :price="totalPrice(activeGame.price.amount)"
        v-on:require-access="requestGamePurchase()"
        v-on:dialog-selected="showDialog($event)"></ep-require-access>
    </div>
  </div>
</template>

<script>
import { mapState, mapGetters, mapActions } from 'vuex'

import { getBrowserName } from '~/utils/device'

import Ep404 from '~components/404'
import Spinner from '~components/Spinner'

import stripeUtil from '~/utils/stripeUtil'
import priceUtil from '~/utils/priceUtil'

import GameItemVert from '~components/Game/ItemVert'
import RequireAccess from '~components/Play/RequireAccess'
import BrowserSupport from '~components/Play/BrowserSupport'

export default {
  name: 'ep-play-view',
  components: {
    'ep-404': Ep404,
    'ep-spinner': Spinner,
    'ep-game-item-vert': GameItemVert,
    'ep-require-access': RequireAccess,
    'ep-browser-support': BrowserSupport
  },
  fetch ({ store, params }) {
    return store.dispatch('getActiveGame', params.gid)
    .then(game => {
      store.dispatch('app/updateHeaderTitle', `${game.title}`)
      store.dispatch('app/resetShow404')
    })
    .catch(() => {
      store.dispatch('app/show404Message')
    })
  },
  data () {
    return {
      gid: '',
      env: '',
      hasAccess: false,
      accessMessage: '',
      isAccessVerified: false,
      accessRequired: false,
      ignoreBrowserSupport: false,
      label: {
        ENV_LIVE: 'live',
        ENV_STAGE: 'stage',
        DESKTOP: 'desktop',
        MOBILE: 'mobile'
      },
      countdownTimer: 10,
      countdownTimerPulse: false
    }
  },
  head () {
    if (!this.activeGame.uid) {
      return {}
    }

    let url = `${process.env.HOST_URL_WWW}/game/${this.activeGame.gid}`
    let title = `${this.activeGame.title} | by ${this.activeGame.publisher.alias}`
    let showDescription = this.activeGame.description.length > 200 ? `${this.activeGame.description.substr(0, 200)}...` : this.activeGame.description
    let description = `Play on Enoplay - ${showDescription}`
    let image = `${this.activeGame.thumbnail}`

    return {
      title: title,
      meta: [
        { hid: 'description', name: 'description', content: description },
        { hid: 'og:url', property: 'og:url', content: url },
        { hid: 'og:title', property: 'og:title', content: title },
        { hid: 'og:description', property: 'og:description', content: description },
        { hid: 'og:image', property: 'og:image', content: image },
        { hid: 'twitter:card', property: 'twitter:card', content: 'summary_large_image' },
        { hid: 'twitter:site', property: 'twitter:site', content: '@enoplay' },
        { hid: 'twitter:url', property: 'twitter:url', content: url },
        { hid: 'twitter:title', property: 'twitter:title', content: title },
        { hid: 'twitter:description', property: 'twitter:description', content: description },
        { hid: 'twitter:image', property: 'twitter:image', content: image }
      ]
    }
  },
  watch: {
    darkHeader (isDark) {
      if (isDark) {
        return
      }

      this.checkIfFrameHasFocus()
    },
    '$route.params.gid' () {
      this.initData()
    }
  },
  mounted () {
    this.initData()
  },
  destroyed () {
    this.ignoreMessages()
  },
  computed: {
    ...mapState('app', [
      'darkHeader',
      'show404'
    ]),
    ...mapGetters([
      'activeGame',
      'activeGameApp',
      'profile'
    ]),
    gameWebURL () {
      let webURL = ''

      switch (this.env) {
        case this.label.ENV_LIVE:
          webURL = this.activeGame.app.webURL
          break
        case this.label.ENV_STAGE:
          webURL = this.activeGameApp.devWebURL
          break
        default:
          webURL = this.activeGame.app.webURL
      }

      return webURL
    },
    hasBrowserSupport () {
      if (!this.activeGame || !this.activeGame.systemSupport || !this.activeGame.systemSupport.browser) {
        return
      }

      let browser = this.profile.deviceSettings.browser
      let device = this.profile.deviceSettings.device

      return this.activeGame.systemSupport.browser[browser][device]
    }
  },
  methods: {
    ...mapActions('app', [
      'setDarkHeader',
      'show404Message',
      'resetShow404'
    ]),
    initData () {
      let gid = this.$route.params.gid
      let env = this.$route.query.env
      this.gid = gid || ''
      this.env = env || ''

      this.startCountdownTimer()

      return this.getGame(gid)
      .then(() => {
        if (this.env) {
          return this.getGameApp(this.activeGame.app.aid)
        }
      })
      .then(() => {
        this.resetShow404()
      })
      .catch(() => {
        this.show404Message()
      })
    },
    getGame (gid) {
      if (!gid) {
        return Promise.reject('invalid gid')
      }

      return this.$store.dispatch('getActiveGame', gid)
      .catch(err => {
        return Promise.reject(err)
      })
      // Ensure profile is retrieved
      .then(() => {
        if (!this.profile.isLoggedIn) {
          return this.$store.dispatch('getProfileInfo')
        }
      })
      // Verify game play access
      .then(() => {
        return this.$store.dispatch('verifyGamePlayAccess', gid)
      })
      .then(response => {
        this.hasAccess = response.hasAccess
        this.isAccessVerified = true

        if (!this.hasAccess) {
          this.showAccessRequiredMessage()
          this.initPaymentForm()

          if (!this.profile.isLoggedIn) {
            // this.showDialog('signin')
            return
          }
        }

        this.setDarkHeader(true)
        this.listenToMessages()
      })
    },
    getGameApp (aid) {
      return this.$store.dispatch('getGameApp', aid)
    },
    listenToMessages () {
      window.addEventListener('message', this.messageHandler)
    },
    ignoreMessages () {
      window.removeEventListener('message', this.messageHandler)
    },
    messageHandler (event) {
      let data = event.data

      if (data.message === 'tokenRequest') {
        this.$store.dispatch('getGamePlayToken', this.gid)
        .then(token => {
          this.$refs.frame.contentWindow.postMessage({
            message: 'verifyToken',
            token
          }, this.gameWebURL)
        })
      }
    },
    initPaymentForm () {
      return new Promise((resolve, reject) => {
        stripeUtil.initCheckout(resolve, this.submitPaymentForm)
      })
    },
    submitPaymentForm (token) {
      this.$store.dispatch('purchaseGame', {
        gid: this.gid,
        token
      })
      .then(() => {
        window.location.reload()
      })
    },
    requestGamePurchase () {
      if (!this.profile.isLoggedIn) {
        this.showDialog('signin')
        return
      }

      stripeUtil.openPaymentDialog({
        amount: this.activeGame.price.amount || 0,
        name: this.activeGame.title,
        description: `by ${this.activeGame.publisher.alias}`,
        email: this.profile.email,
        image: this.activeGame.thumbnail
      })
    },
    setToken (token) {
      this.$refs.frame.contentWindow.postMessage({
        message: 'setToken',
        token
      }, '*')
    },
    totalPrice (price) {
      return priceUtil.totalPrice(price)
    },
    checkIfFrameHasFocus () {
      window.setTimeout(() => {
        if (document.activeElement === this.$refs.frame) {
          this.setDarkHeader(true)
        } else {
          this.checkIfFrameHasFocus()
        }
      }, 2000)
    },
    setFrameFocus () {
      this.$refs.frame.focus()
    },
    browserDeviceList (device) {
      if (!this.activeGame || !this.activeGame.systemSupport || !this.activeGame.systemSupport.browser) {
        return
      }

      let list = []
      let browsers = this.activeGame.systemSupport.browser

      for (let browserUID in browsers) {
        if (!browsers[browserUID][device]) {
          continue
        }

        list.push({
          uid: browserUID,
          name: getBrowserName(browserUID)
        })
      }

      return list
    },
    startCountdownTimer () {
      if (this.countdownTimer <= 0) {
        return
      }
      this.countdownTimerPulse = true

      setTimeout(() => {
        this.countdownTimerPulse = false
        this.countdownTimer -= 1
        this.startCountdownTimer()
      }, 2000)
    },
    setIgnoreBrowserSupport (value) {
      this.ignoreBrowserSupport = value
    },
    show404Message () {
      this.$store.dispatch('app/show404Message')
    },
    showAccessRequiredMessage () {
      this.accessRequired = true
    },
    showDialog (option) {
      this.$emit('dialog-selected', option)
    }
  }
}
</script>

<style lang="scss" scoped>
@import '~assets/styles/theme';
@import '~assets/styles/input';


$thumbnail-width: 196px;
$thumbnail-height: 110px;

$message-horiz-padding: 20px;
$game-details-item-width: calc(320px - #{$message-horiz-padding} - #{$message-horiz-padding});

.play-view {
  position: relative;
  background: $light-apricot;
  height: calc(100vh - 50px);
}

.game-container, .game-frame-container {
  position: absolute;
  top: 0;
  left: 0;
  width: 100vw;
  height: calc(100vh - 50px);
}

.game-frame-container {
  z-index: 1;
}

.game-frame {
  width: 100%;
  height: 100%;
}

.spinner-icon {
  position: absolute;
  z-index: 0;
  left: 0;
  right: 0;
  top: 0;
  margin: auto;
}

.countdown-timer {
  text-align: center;
  padding: 20px 0;
  font-size: 32px;
  color: $text-color;

  &.hide {
    display: none;
  }

  &.pulse {
    -webkit-animation: pulsate 2s ease-out;
    -webkit-animation-iteration-count: infinite;
    opacity: 0;
  }
}

.access-required-message, .ep-404 {
  position: absolute;
  z-index: 1;
  padding: $message-horiz-padding;
  background: $light-apricot;
}

.game-details-item-container {
  position: relative;
  width: calc(100vw - #{$message-horiz-padding} - #{$message-horiz-padding});
  height: auto;
}

.game-details-item, .require-access {
  max-width: $game-details-item-width;
  overflow: hidden;
  position: relative;
  margin: 0 auto;
}

.require-access {
  margin-top: 12px;
}

@keyframes pulsate {
  0% { opacity: 0; }
  50% { opacity: 1.0; }
  100% { opacity: 0; }
}
</style>
